#include "../Headers/timer.h"

#include <stdint.h>

//////////////////////////////////// Macros

// The loop of WaitSecond() function counts until this value, in order to measure 1 sec
// TODO - this value isn't calibrated yet, it's just a placeholder
#define SECOND_COUNTER_MAX   1000000


//////////////////////////////////// Functions


void WaitSecond(void)
{
    volatile uint32_t i;

	// This for loop has no effect outside of the WaitSecond() function,
	// and the compiler also knows this. But the compiler doesn't know
	// that time is elapsing while this loop is running, although that's
	// exactly what we want to exploit. If i was not a volatile variable,
	// then the entire for loop might be deleted by the compiler
	// during optimization.
    for (i = 0; i < SECOND_COUNTER_MAX; i++)
    {
        // Intentionally empty loop body.
		// The waiting is achieved by increasing the index variable i one by one.
    }
}
